-- DEMO1.EX : demonstrate how to write a simple script with the commands
--            that come provided.

-- include the scripting engine routines
include engine.e

-- this variable will hold the 'script'
sequence thescript

-- now define the script.
-- commands are defined like so : {LABEL, COMMAND, PARAMS}
-- where LABEL is the label of the instruction(you can use "" if the instruction
-- doesn't need a lable), COMMAND is a string value specifying the command to
-- execute, this command must have been added before with the add_command()
-- procedure. and PARAMS are the parameters that the command will use.

thescript =
{
  -- defines a variable called 'var' and assigns "Foo" to it.
  -- use a '$' character in front a variable name to refence it
  -- note: When a command's parameters should be the name of a variable
  --       you don't need the '$' character in front of the name. the '$'
  --       character is only needed when either a variable or literal
  --       expression can be passed. if you use the '$' character where
  --       it is not needed, the scripting engine will put the value of that
  --       variable there instead of it's name.
  --       ie : {"","ADD",{2,2,"num"}} will not have the same results as
  --            {"","ADD",{2,2,"$num"}}. if $num = "myvar" then that statement
  --            would turn into : {"","ADD",{2,2,"myvar"}}

  {"","STORE",{"var","Foo"}},

  -- Checks to see the value stored in 'var' is = to 'Foo' if it is
  -- it will go to the instruction with label 'yes' or else it will go
  -- to the instruction with the label 'no'
  {"","EQUAL",{"$var","Foo","yes","no"}},

  -- the last two instructions do nothing but prevent an error.
  {"yes","PUTS",{"Yes\n"}},
  {"","GOTO",{"skip"}},

  {"no","PUTS",{"No\n"}},
  {"","GOTO",{"skip"}},

  -- demonstrate how to do simple math using the 4 math commands that
  -- are provided
  {"skip","NOOP",{}},
  {"","STORE",{"var",1}},
  {"","ADD",{"$var",1,"var"}},
  {"","SUB",{"$var",1,"var"}},
  {"","MUL",{"$var",1,"var"}},
  {"","DIV",{4,"$var","var"}},
  {"","PUTI",{"$var"}},
  {"","PUTS",{"\n"}},

  -- demonstrate how to use the GOTO command
  {"","GOTO",{"next"}},
  {"","NOOP",{}},
  {"next","noOp",{}}

} -- end of script.

-- now execute the script
puts(1,"-- SCRIPT OUTPUT -- \n")
execute(thescript)
puts(1,"-- END OF SCRIPT -- \n")

