-- U.D.S.E : User Defineable Scripting Engine.

include assoc.e

global constant
  INST_LABEL   = 1,
  INST_COMMAND = 2,
  INST_PARAMS  = 3

sequence script,stack,commands
integer cl,over

commands = {}

global function parse_params(sequence p)
  sequence ret,keyname
  object val,prm
  integer stop
  ret = repeat(0,length(p))
  for i = 1 to length(ret) do
    prm = p[i]
    if sequence(prm) then
      stop = length(prm)
      if prm[1] = '$' then
	keyname = prm[2..stop]
	val = getKey(stack,keyname)
	ret[i] = val
      else
	ret[i] = p[i]
      end if
    else
      ret[i] = p[i]
    end if
  end for
  return ret
end function

global procedure add_command(sequence name, integer p)
  commands = addKey(commands,name,p)
end procedure

global procedure set_var(sequence name, object val)
  stack = setKey(stack,name,val)
end procedure

global function get_var(sequence name)
  object ret
  ret = 0
  if findKey(stack,name)=0 then
    set_var(name,0)
  else
    ret = getKey(stack,name)
  end if
  return ret
end function

global procedure goto(sequence label)
  integer p
  for i = 1 to length(script) do
    if equal(label,script[i][INST_LABEL]) then
      p = i
      exit
    end if
  end for
  cl = p-1
end procedure

global procedure execute(sequence s)
  sequence param,cmd,inst
  integer proc

  script = s
  stack = {}
  cl = 0
  over = 0
  while cl < length(script) and over = 0 do
    cl = cl + 1
    inst = script[cl]
    cmd = inst[INST_COMMAND]
    param = parse_params(inst[INST_PARAMS])
    proc = getKey(commands, cmd)
    if proc > 0 then
      call_proc(proc,param)
    end if
  end while
end procedure

include predef.e


