-- Key-Value List routines
include wildcard.e

global constant KEY_NAME = 1, KEY_VALUE = 2

global function findKey(sequence seq, sequence name)
  integer ret
  sequence s1,s2
  ret = 0
  s1 = lower(name)
  for i = 1 to length(seq) do
    s2 = lower(seq[i][1])
    if equal(s1,s2) then
      ret = i
      exit
    end if
  end for
  return ret
end function

global function addKey(sequence seq, sequence keyName, object val)
  sequence newseq
  newseq = seq
  if findKey(seq,keyName)=0 then
    newseq = append(newseq,{keyName,val})
  end if
  return newseq
end function

global function delKey(sequence seq, sequence keyName)
  integer kp
  sequence newseq
  kp = findKey(seq,keyName)
  newseq = {}
  for i = 1 to length(seq) do
    if i != kp then
      newseq = append(newseq, seq[i])
    end if
  end for
  return newseq
end function

global function getKey(sequence seq, sequence keyName)
  integer kp
  kp = findKey(seq, keyName)
  if kp > 0 then
    return seq[kp][2]
  else
    return 0
  end if
end function

global function setKey(sequence seq, sequence keyName, object val)
  integer kp
  sequence s
  s = seq
  kp = findKey(s,keyName)
  if kp > 0 then
    s[kp][2] = val
  else
    s = addKey(s,keyName,val)
  end if
  return s
end function

